本文编写于 129 天前,最后修改于 129 天前,其中某些信息可能已经过时。

什么是异常

尽管人人希望自己身体健康,处理的事情都能顺利进行,但在实际生活中总会遇到各种状况,比如感冒发烧,工作时电脑蓝屏、死机等。同样在程序运行的过程中,也会发生各种非正常状况,比如程序运行时磁盘空间不足,网络连接中断,被装载的类不存在。针对这种情况,在Java语言中,引入了异常,以异常类的形式对这些非正常情况进行封装,通过异常处理机制对程序运行时发生的各种问题进行处理。接下来通过一个案例来认识一下什么是异常,如例所示。

public class Example {
    public static void main(String[] args) {
        int result = divide(4, 0); // 调用divide()方法
        System.out.println(result);
    }
    // 下面的方法实现了两个整数相除
    public static int divide(int x, int y) {
        int result = x / y; // 定义一个变量result 记录两个数相除的结果
        return result; // 将结果返回
    }
}

运行结果:

Exception in thread "main" java.lang.ArithmeticException: / by zero
    at Example.divide(Example.java:9)
    at Example.main(Example.java:3)

从运行结果可以看出,程序发生了算数异常(ArithmeticException),这个异常是由于程序中的第3行代码调用divide()方法时传入了参数0,在方法中的第8行代码的运算中出现了被0除的错误。在这个异常发生后,程序会立即结束,无法继续向下执行。

例中产生了一个ArithmeticException异常,ArithmeticException异常只是Java异常类中的一种,在Java中还提供了大量的异常类,这些类都继承自java.lang.Throwable类。接下来通过一张图来展示Throwable类的继承体系,如图所示。

通过图可以看出,Throwable有两个直接子类Error和Exception,其中Error代表程序中产生的错误,Exception代表程序中产生的异常。接下来就对这两个直接子类进行详细讲解。

  • Error类

Error类称为错误类,它表示Java运行时产生的系统内部错误或资源耗尽的错误,是比较严重的,仅靠修改程序本身是不能恢复执行的。举一个生活中的例子,在盖楼的过程中因偷工减料,导致大楼坍塌,这就相当于一个Error。

  • Exception类

Exception类称为异常类,它表示程序本身可以处理的错误,在开发Java程序中进行的异常处理,都是针对Excption类及其子类。在Exception类的众多子类中有一个特殊的RuntimeException类,该类及其子类用于表示运行时异常,除了此类,Exception类下所有其他的子类都用于表示编译时异常。本节主要针对Exception类及其子类进行讲解。

通过前面的学习我们已经了解了Throwable类,为了方便后面的学习,接下来将Throwable类中的常用方法罗列出来,如表所示。

表中的这些方法都用于获取异常信息。由于Error和Exception 继承自Throwable类,所以它们都拥有这些方法,在后面的异常学习中会逐渐接触到这些方法的使用。

try…catch和finally

上面的例子中,由于发生了异常,程序立即终止,无法继续向下执行。为了解决这样的问题,Java中提供了一种对异常进行处理的方式———异常捕获。异常捕获通常使用try…catch语句,具体语法格式如下:

try{
//程序代码块
}catch(ExceptionType(Exception 类及其子类) e){
//对ExceptionType 的处理
}

其中在try代码块中编写可能发生异常的Java语句,catch代码块中编写针对异常进行处理的代码。当try代码块中的程序发生了异常,系统会将这个异常的信息封装成一个异常对象,并将这个对象传递给catch代码块。catch代码块需要一个参数指明它所能够接收的异常类型,这个参数的类型必须是Exception类或其子类。

接下来使用try…catch语句对上面例中出现的异常进行捕获。

public class Example {
    public static void main(String[] args) {
        // 下面的代码定义了一个try…catch 语句用于捕获异常
        try {
            int result = divide(4, 0); // 调用divide()方法
            System.out.println(result);
        } catch (Exception e) { // 对异常进行处理
            System.out.println("捕获的异常信息为: " + e.getMessage());
        }
        System.out.println("程序继续向下执行……");
    }
    // 下面的方法实现了两个整数相除
    public static int divide(int x, int y) {
        int result = x / y; // 定义一个变量result 记录两个数相除的结果
        return result; // 将结果返回
    }
}

运行结果:

捕获的异常信息为: / by zero
程序继续向下执行……

例中,对可能发生异常的代码用try…catch语句进行了处理。在try代码块中发生被0 除异常,程序会转而执行catch 中的代码,通过调用Exception 对象的getMessage()方法,返回异常信息“/byzero”。catch代码块对异常处理完毕后,程序仍会向下执行,而不会异常终止。

在程序中,有时候我们希望有些语句无论程序是否发生异常都要执行,这时就可以在try…catch 语句后,加一个finally代码块。接下来对例4-22 进行修改,演示一下finally代码块的用法,如例所示。

public class Example {
    public static void main(String[] args) {
        // 下面的代码定义了一个try…catch 语句用于捕获异常
        try {
            int result = divide(4, 0); // 调用divide()方法
            System.out.println(result);
        } catch (Exception e) { // 对异常进行处理
            System.out.println("捕获的异常信息为: " + e.getMessage());
        } finally {
            System.out.println("进入finally 代码块");
        }
        System.out.println("程序继续向下执行……");
    }
    // 下面的方法实现了两个整数相除
    public static int divide(int x, int y) {
        int result = x / y; // 定义一个变量result 记录两个数相除的结果
        return result; // 将结果返回
    }
}

运行结果:

捕获的异常信息为: / by zero
进入finally 代码块
程序继续向下执行……

在catch代码块中增加了一个return语句,用于结束当前方法,此时程序第12行代码就不会执行了,而finally中的代码仍会执行,并不会被return语句所影响,也就是说不论程序是发生异常还是使用return语句结束,finally中的语句都会执行,正是由于这种特殊性,在程序设计时,经常会在try…catch后使用finally代码块来完成必须做的事情,例如释放系统资源。

需要注意的是,finally中的代码块有一种情况下是不会执行的,那就是在try…catch中执行了System.exit(0)语句。System.exit(0)表示退出当前的Java虚拟机,Java虚拟机停止了,任何代码都不能再执行了。

throws关键字

在前面学习的例中,由于调用的是自己写的divide()方法,因此很清楚该方法可能会发生异常。试想一下,如果去调用一个别人写的方法时,是否能知道别人写的方法是否会有异常呢? 这是很难做出判断的。针对这种情况,Java中允许在方法的后面使用throws关键字对外声明该方法有可能发生的异常,这样调用者在调用方法时,就明确地知道该方法有异常,并且必须在程序中对异常进行处理,否则编译无法通过。

throws关键字声明抛出异常的语法格式如下:

修饰符返回值类型方法名([参数1,参数2…])throws ExceptionType1[,ExceptionType2…]{
}

从上述语法格式中可以看出,throws关键字需要写在方法声明的后面,throws后面需要声明方法中发生异常的类型,通常将这种做法称为方法声明抛出一个异常。然后使用同样的try catch 结构抛出异常,就保证了程序执行时不会终止,接下来对例进行修改,在devide()方法上声明抛出异常,如例所示。

public class Example {
    public static void main(String[] args) {
        // 下面的代码定义了一个try…catch 语句用于捕获异常
        try {
            int result = divide(4, 2); // 调用divide()方法
            System.out.println(result);
        } catch (Exception e) { // 对捕获到的异常进行处理
            e.printStackTrace(); // 打印捕获的异常信息
        }
    }
    // 下面的方法实现了两个整数相除,并使用throws 关键字声明抛出异常
    public static int divide(int x, int y) throws Exception {
        int result = x / y; // 定义一个变量result 记录两个数相除的结果
        return result; // 将结果返回
    }
}

运行结果:

2

运行时异常与编译时异常

在实际开发中,经常会在程序编译时产生一些异常,而这些异常必须要进行处理,这种异常被称为编译时异常,也称为checked异常。另外还有一种异常是在程序运行时产生的,这种异常即使不编写异常处理代码,依然可以通过编译,因此称为运行时异常,也称为unchecked异常。接下来就分别对这两种异常进行详细的讲解。

编译时异常

在Java中,Exception类中除了RuntimeException类及其子类都是编译时异常。编译时异常的特点是Java编译器会对其进行检查,如果出现异常就必须对异常进行处理,否则程序无法通过编译。

处理编译时期的异常有两种方式,具体如下:

  • 使用try…catch语句对异常进行捕获。
  • 使用throws关键字声明抛出异常,调用者对其处理。

运行时异常

RuntimeException类及其子类都是运行时异常。运行时异常的特点是Java编译器不会对其进行检查,也就是说,当程序中出现这类异常时,即使没有使用try…catch语句捕获或使用throws关键字声明抛出,程序也能编译通过。运行时异常一般是由程序中的逻辑错误引起的,在程序运行时无法恢复。比如通过数组的角标访问数组的元素时,如果超过了数组的最大角标,就会发生运行时异常,代码如下所示:

int [] arr = new int[5];
System.out.println(arr[6]);

上面代码中,由于数组arr的length为5,最大角标应为4,当使用arr[6]访问数组中的元素就会发生数组角标越界的异常。

自定义异常

JDK中定义了大量的异常类,虽然这些异常类可以描述编程时出现的大部分异常情况,但是在程序开发中有时可能需要描述程序中特有的异常情况,例如在设计divide()方法时不允许被除数为负数。为了解决这个问题,在Java中允许用户自定义异常,但自定义的异常类必须继承自Exception或其子类。接下来通过一个案例来学习,如例所示。

//下面的代码是自定义一个异常类继承自Exception
public class DivideByMinusException extends Exception {
    public DivideByMinusException() {
        super(); // 调用Exception 无参的构造方法
    }
    public DivideByMinusException(String message) {
        super(message); // 调用Exception 有参的构造方法
    }
}

在实际开发中,如果没有特殊的要求,自定义的异常类只需继承Exception类,在构造方法中使用super()语句调用Exception的构造方法即可。

既然自定义了异常,那么该如何使用呢? 这时就需要用到throw关键字,throw关键字用于在方法中声明抛出异常的实例对象,其语法格式如下:

throw Exception 异常对象

接下来重新对上面被除数为0的例子中的divide()方法进行改写,在divide()方法中判断被除数是否为负数,如果为负数,就使用throw 关键字在方法中向调用者抛出自定义的DivideByMinusException异常对象,如例所示。

public class Example {
    public static void main(String[] args) {
        // 下面的代码定义了一个try…catch 语句用于捕获异常
        try {
            // 调用divide()方法,传入一个负数作为被除数
            int result = divide(4, -2);
            System.out.println(result);
        } catch (DivideByMinusException e) { // 对捕获到的异常进行处理
            System.out.println(e.getMessage()); // 打印捕获的异常信息
        }
    }
    // 下面的方法实现了两个整数相除,并使用throws 关键字声明抛出自定义异常
    public static int divide(int x, int y) throws DivideByMinusException {
        if (y < 0) {
            // 使用throw 关键字声明异常对象
            throw new DivideByMinusException("被除数是负数");
        }
        int result = x / y; // 定义一个变量result 记录两个数相除的结果
        return result; // 将结果返回
    }
}

运行结果:

被除数是负数

例的main()方法中,定义了一个try…catch语句用于捕获divide()方法抛出的异常。在调用divide()方法时由于传入的被除数不能为负数,程序会抛出一个自定义异常DivideByMinusException,该异常被捕获后最终被catch代码块处理,并打印出异常信息。